#    Copyright (C) 1996 Aladdin Enterprises.  All rights reserved.
# 
# This file is part of Aladdin Ghostscript.
# 
# Aladdin Ghostscript is distributed with NO WARRANTY OF ANY KIND.  No author
# or distributor accepts any responsibility for the consequences of using it,
# or for whether it serves any particular purpose or works at all, unless he
# or she says so in writing.  Refer to the Aladdin Ghostscript Free Public
# License (the "License") for full details.
# 
# Every copy of Aladdin Ghostscript must include a copy of the License,
# normally in a plain ASCII text file named PUBLIC.  The License grants you
# the right to copy, modify and redistribute Aladdin Ghostscript, but only
# under certain conditions described in the License.  Among other things, the
# License requires that the copyright notice and this notice be preserved on
# all copies.

# Common partial makefile for MS-Windows DLLs.

# Creating the icons from their text form.

ICONS=gsgraph.ico gstext.ico

gsgraph.ico: gsgraph.icx $(ECHOGS_XE)
	echogs -wb gsgraph.ico -n -X -r gsgraph.icx

gstext.ico: gstext.icx $(ECHOGS_XE)
	echogs -wb gstext.ico -n -X -r gstext.icx

# Compile the small EXE loader.

DWOBJ=dwdll.obj dwimg.obj dwmain.obj dwtext.obj gscdefs.obj

dwdll.obj: dwdll.cpp dwdll.h gsdll.h

dwimg.obj: dwimg.cpp dwmain.h dwdll.h dwtext.h dwimg.h gscdefs.h gsdll.h

dwmain.obj: dwmain.cpp dwdll.h gscdefs.h gsdll.h

dwtext.obj: dwtext.cpp dwtext.h

$(GS).res: dwmain.rc dwmain.h $(ICONS)
	$(COMPDIR)\$(RCOMP) -i$(INCDIR) -r -fo$(GS).res dwmain.rc

# Compile gsdll.c, the main program of the DLL.

gsdll.$(OBJ): gsdll.c gsdll.h $(ghost_h)
