.TH DPSCLOCK 1 "3 Jun 1994" "Adobe Systems"
.SH NAME
dpsclock - analog / digital clock using DPS
.SH SYNOPSIS
.ta 8n
\fBdpsclock\fP	[-\fItoolkitoption\fP ...] [-help] [-analog] [-digital] [-font \fIfontname\fP] 
.br
	[-update \fIseconds\fP] [-padding \fInumber\fP]
.SH DESCRIPTION
The
.I dpsclock 
program displays the time in analog or digital form.  The time is continuously
updated at a frequency which may be specified by the user.  This program is
displays using the Display PostScript system, and so adjusts either the
analog or digital display to match the current size and shape of the window.
.SH OPTIONS
.I Dpsclock
accepts all of the standard X Toolkit command line options along with the 
additional options listed below:
.TP 8
.B \-help
This option indicates that a brief summary of the allowed options should be
printed on the standard error.
.TP 8
.B \-analog 
This option indicates that a conventional 12 hour clock face with tick marks
and hands should be used.  This is the default.
.TP 8
.B \-digital
This option indicates that a 24 hour digital clock should be used.
.TP 8
.B \-font \fIfontname\fP
This option specifies the font to be used for the number in the analog
clock or for all text in the digital clock.  It should be a string that
is the name of an installed font.  The default is "Times-Roman".
.TP 8
.B \-update \fIseconds\fP
This option specifies the frequency in seconds at which \fIdpsclock\fP
should update its display.  If the clock is obscured and then exposed,
it will be updated immediately.  A value of less than 30 seconds will enable a
second hand on an analog clock.  The default is 60 seconds.
.TP 8
.B \-padding \fInumber\fP
This option specifies the width in pixels of the padding 
between the window border and clock text or picture.  The default is 8.
.SH X DEFAULTS
The program understands the following X defaults in addition to the defaults:
.PP
.TP 8
.B update (\fPclass\fB Interval)
Specifies the frequency in seconds at which the time should be redisplayed.
The default is 60.
.TP 8
.B analog (\fPclass\fB Boolean)
Specifies whether or not an analog clock should be used instead of a digital
one.  The default is True.
.TP 8
.B padding (\fPclass\fB Margin)
Specifies the amount of internal padding in pixels to be used.  The default is
8.
.TP 8
.B font (\fPclass\fB String)
Specifies the font to be used for the numbers in the analog font or the
text in the digital clock.  The default is "Times-Roman".
.SH ENVIRONMENT
.PP
.TP 8
.B DISPLAY
to get the default host and display number.
.SH COPYRIGHT
Copyright 1989, Massachusetts Institute of Technology, and 1990-1994,
Adobe Systems Incorporated
.SH AUTHOR
.LP
Adobe Systems Incorporated
.SH NOTES
.LP
PostScript and Display PostScript are trademarks
of Adobe Systems Incorporated which may be registered
in certain jurisdictions.



