/* 
   EOAssociation.m

   Copyright (C) 1996 Free Software Foundation, Inc.

   Author: Mircea Oancea <mircea@jupiter.elcom.pub.ro>
   Date: November 1996

   This file is part of the GNUstep Database Library.

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with this library; see the file COPYING.LIB.
   If not, write to the Free Software Foundation,
   59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#include <eoaccess/common.h>

#if NeXT_foundation_LIBRARY
typedef void NXTypedStream;
#endif

#include <eointerface/EOAssociation.h>
#include <eointerface/EOController.h>

@implementation EOAssociation

- initWithController:(EOController*)aController 
  key:(NSString*)aKey
  destination:aDestination
{
	[self init];
	controller = aController;
	destination = [aDestination retain];
	key = [aKey copy];
	return self;
}

- (void)dealloc
{
	[destination release];
	[key release];
	[super dealloc];
}

- (EOController*)controller
{
	return controller;
}

- destination
{
	return destination;
}

- (NSString*)key
{
	return key;
}

- value
{
	return nil;
}

- (void)contentsDidChange 
{
}

- (void)selectionDidChange
{
}

- (void)endEditing 
{
}

- (void)discardEdits 
{
}

@end /* EOAssociation */
