/* 
   loop.m

   Copyright (C) 1996 Free Software Foundation, Inc.

   Author: Ovidiu Predescu <ovidiu@bx.logicnet.ro>
   Date: 1996

   This file is part of the GNUstep Database Library.

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with this library; see the file COPYING.LIB.
   If not, write to the Free Software Foundation,
   59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#include <Foundation/NSObjCRuntime.h>

#include <extensions/NSException.h>
#include <extensions/exceptions/GeneralExceptions.h>

#include "driver.h"

void loop(void)
{
    int ret;

    puts(__FUNCTION__);

    while(1)
	action;

    puts("driver returned from " __FUNCTION__);
}

void try_catch(void)
{
    int ret = -1;

    puts(__FUNCTION__);

    TRY {
	while(1) {
	    ret = do_action();
	    if(ret == BREAK_LOOP)
		break;
	    else if(ret == END_OF_INPUT)
		exit(0);
	}
    } END_TRY
    OTHERWISE {
	printf("caught exception %u\n", (unsigned)localException);
	while(1) {
	    ret = do_action();
	    if(ret == BREAK_LOOP)
		break;
	    else if(ret == END_OF_INPUT)
		exit(0);
	}
    }
    END_CATCH;
	
    puts("driver returned from " __FUNCTION__);
}
