/* 
   PXKButtonCell.h

   NSButtonCell for GNUstep GUI X/DPS Backend

   Copyright (C) 1996 Free Software Foundation, Inc.

   Author: Ovidiu Predescu <ovidiu@bx.logicnet.ro>
   Date: February 1997
   A completely rewritten version of the original source by Scott Christley.
   
   This file is part of the GNUstep GUI X/DPS Backend.

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with this library; see the file COPYING.LIB.
   If not, write to the Free Software Foundation,
   59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/ 

#ifndef _GNUstep_H_PXKButtonCell
#define _GNUstep_H_PXKButtonCell

#include <AppKit/NSButtonCell.h>

@interface PXKButtonCell : NSButtonCell
@end


@interface PXKButtonCell (PXKCellMethods)
- (void)_displayImage:(NSImage*)image inFrame:(NSRect)frame;
- (void)_displayTitle:(NSString*)title
  inFrame:(NSRect)frame
  titleGray:(float)titleGray;
@end


#endif /* _GNUstep_H_PXKButtonCell */
