/* 
   EODetailDatabaseDataSource.h

   Copyright (C) 1996 Free Software Foundation, Inc.

   Author: Mircea Oancea <mircea@jupiter.elcom.pub.ro>
   Date: 1996

   This file is part of the GNUstep Database Library.

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with this library; see the file COPYING.LIB.
   If not, write to the Free Software Foundation,
   59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef __EODetailDatabaseDataSource_h__
#define __EODetailDatabaseDataSource_h__

#include <Foundation/NSObject.h>
#include <eoaccess/EODataSources.h>

@class NSArray;
@class EODatabaseChannel;
@class EOEntity;
@class EOQualifier;
@class EODatabaseDataSource;

@interface EODetailDatabaseDataSource : NSObject 
<EOMasterDataSources, EOQualifiableDataSources, EORollbackDataSources>
{
    EODatabaseDataSource*	masterDataSource;
    id 				masterObject;
    NSString*			masterKey;
    EOEntity*			currentEntity;
    NSArray*			array;
    NSMutableArray*		objects;
    
    // These should be bitfield but are left so for debugging
    
    BOOL			isToMany;
    BOOL			isUnsincronized;
}

// Initializing instances
- initWithMasterDataSource:(EODatabaseDataSource*)aMasterDataSource
  entity:(EOEntity*)anEntity;

// Getting the master data source
- (EODatabaseDataSource*)masterDataSource;

// Getting the entity
- (EOEntity*)entity;

// Getting the detail key
- (NSString*)detailKey;

// Getting the objects
- masterObject;
- (NSArray*)array;

@end /* EODetailDatabaseDataSource */

#endif		/* __EODetailDatabaseDataSource_h__ */
