/* 
   MyEOModelClasses.m

   Copyright (C) 1996 Free Software Foundation, Inc.

   Author: Ovidiu Predescu <ovidiu@bx.logicnet.ro>
   Date: 1996

   This file is part of the GNUstep Database Library.

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with this library; see the file COPYING.LIB.
   If not, write to the Free Software Foundation,
   59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#include <stdio.h>
#include "MyEOModelClasses.h"

@implementation MyEOModel

static BOOL EOModelDebug = NO;

+ (void)setDebug:(BOOL)flag	{ EOModelDebug = flag; }

- (void)dealloc
{
    if(EOModelDebug)
	printf("EOModel %u dealloc\n", (unsigned)self);
    [super dealloc];
}

@end /* MyEOModel */


@implementation MyEOEntity

static BOOL EOEntityDebug = NO;

+ (void)setDebug:(BOOL)flag	{ EOEntityDebug = flag; }

- (void)dealloc
{
    if(EOEntityDebug)
	printf("EOEntity %u dealloc\n", (unsigned)self);
    [super dealloc];
}

@end /* MyEOEntity */


@implementation MyEOAttribute

static BOOL EOAttributeDebug = NO;

+ (void)setDebug:(BOOL)flag	{ EOAttributeDebug = flag; }

- (void)dealloc
{
    if(EOAttributeDebug)
	printf("EOAttribute %u dealloc\n", (unsigned)self);
    [super dealloc];
}

@end /* MyEOAttribute */


@implementation MyEORelationship

static BOOL EORelationshipDebug = NO;

+ (void)setDebug:(BOOL)flag	{ EORelationshipDebug = flag; }

- (void)dealloc
{
    if(EORelationshipDebug)
	printf("EORelationship %u dealloc\n", (unsigned)self);
    [super dealloc];
}

@end /* MyEORelationship */


@implementation MyEOJoin

static BOOL EOJoinDebug = NO;

+ (void)setDebug:(BOOL)flag	{ EOJoinDebug = flag; }

- (void)dealloc
{
    if(EOJoinDebug)
	printf("EOJoin %u dealloc\n", (unsigned)self);
    [super dealloc];
}

@end /* MyEOJoin */
