/* 
   PXKBitmapImageRep.m

   NSBitmapImageRep for GNUstep GUI X/DPS Backend

   Copyright (C) 1996 Free Software Foundation, Inc.

   Written by:  Adam Fedor <fedor@colorado.edu>
   Date: Feb 1996
   
   This file is part of the GNUstep GUI X/DPS Backend.

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   If you are interested in a warranty or support for this source code,
   contact Scott Christley <scottc@net-community.com> for more information.
   
   You should have received a copy of the GNU Library General Public
   License along with this library; see the file COPYING.LIB.
   If not, write to the Free Software Foundation,
   59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/ 

#include <gnustep/xdps/PXKBitmapImageRep.h>
#include <gnustep/xdps/PXKWindow.h>
#include <gnustep/xdps/PXKDPSContext.h>
#include <gnustep/xdps/PXKScreen.h>

@implementation PXKBitmapImageRep

- (BOOL) draw
{
  XImage *xImage, *xi;
  NSDPSContext *cur = [NSDPSContext currentContext];
  Window xWindow, axw;
  Display *xDisplay;
  NSColor *black = [NSColor blackColor];
  NSColor *gray = [NSColor grayColor];
  GC xGC;
  NSView *v = [NSView focusView];
  char *the_data;

  NSLog(@"PXKBitmapImageRep: draw\n");

  xWindow = [(PXKWindow *)[v window] xWindow];
  xDisplay = [(PXKDPSContext *)cur xDisplay];
  xGC = [(PXKDPSContext *)cur xGC];

  axw = RootWindow(xDisplay, [(PXKScreen *)[NSScreen mainScreen] xScreen]);
  
  xi = XGetImage(xDisplay, axw, 0, 0, 300, 300, AllPlanes, XYPixmap);

  XPutImage(xDisplay, xWindow, xGC, xi, 0, 0, 0, 0, 300, 300);

  NSLog(@"width %d height %d xoffset %d depth %d\n", xi->width, xi->height,
	xi->xoffset, xi->depth);
  NSLog(@"bpl %d bpp %d bitmap_pad %d bbo %d bu %d bo %d\n", 
	xi->bytes_per_line, xi->bits_per_pixel, xi->bitmap_pad,
	xi->bitmap_bit_order, xi->bitmap_unit, xi->byte_order);

  the_data = (char *)[imageData mutableBytes];
  xImage = XCreateImage(xDisplay,
			xWindow,
			1, 
			XYBitmap,
			0,
			the_data,
			_pixelsWide,
			_pixelsHigh,
			8,
			0);

  if (!xImage)
    NSLog(@"Error creating XImage\n");

  XPutImage(xDisplay, xWindow, xGC, xImage, 0, 0, 0, 0, 
	    _pixelsWide, _pixelsHigh);


  return YES;
}

@end
