/* 
   PXKCell.m

   NSCell for GNUstep GUI X/DPS Backend

   Copyright (C) 1996 Free Software Foundation, Inc.

   Author:  Pascal Forget <pascal@wsc.com>
   Date: January 1996
   
   This file is part of the GNUstep GUI X/DPS Backend.

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   If you are interested in a warranty or support for this source code,
   contact Scott Christley <scottc@net-community.com> for more information.
   
   You should have received a copy of the GNU Library General Public
   License along with this library; see the file COPYING.LIB.
   If not, write to the Free Software Foundation,
   59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/ 

#include <gnustep/xdps/PXKCell.h>
#include <AppKit/NSControl.h>

@implementation PXKCell

#if 0
- (NSSize)cellSizeForBounds:(NSRect)aRect;
{
    NSSize invalidSize;
    
    if ((aRect.size.width >= cell_size.width) &&
	(aRect.size.height >= cell_size.height)) {
	return aRect.size;
    } else {
	invalidSize.width = 0.0;
	invalidSize.height = 0.0;
	return invalidSize;
    }
}

- (BOOL)isEntryAcceptable:(NSString *)aString;
{
    BOOL isNumeric = YES;   /* Int, float or double */
    BOOL isPositive = YES;  /* Numeric > 0 */
    BOOL isInt = YES;
    int i=0, count;
    const char *str;
    char c;
    int numberOfDots = 0;
    
    if ((entry_type == NSAnyType) || (aString == nil)) {
	return YES;
    } else {

	count = [aString length];

	str = [aString cString];

	if (entry_type == NSDateType) { /* VERY primitive date validation */
	    
	    for (i=0; i<count; i++) {
		c = str[i];
		if ((c=='k') ||
		    (c=='w') ||
		    (c=='x') ||
		    (c=='z') ||
		    (c<32) ||
		    (c>122))
		{
		    return NO;
		}
	    }
	    return YES;
	    
	} else {   /* Entry is of one of the numeric types */

	    /* Ignore leading blanks and TABS */

	    while (((c=str[i]) == ' ') || (c=='\t')) {
		i++;
	    }

	    /* See if the current char is a minus sign */

	    if (c == '-') {
		isPositive = NO;
	    }

	    for (; i<count; i++) {
		c = str[i];

		if (c == '.') {
		    numberOfDots++;
		    
		    if (numberOfDots > 1) {
			isNumeric = NO;
		    }
		} else {
		    
		    if ((c>'9') || (c < '0')) {
			isNumeric = NO;
		    }
		}
	    }

	    if (isNumeric &&
		isInt &&
		(((float)[aString intValue]) == [aString floatValue]))
	    {
		isInt = YES;
	    } else {
		isInt = NO;
	    }

	    if (entry_type == NSIntType) {
		if (isNumeric && isInt) {
		    return YES;
		} else {
		    return NO;
		}
	    } else if (entry_type == NSPositiveIntType) {
		if (isNumeric && isInt && isPositive) {
		    return YES;
		} else {
		    return NO;
		}
	    } else if (entry_type == NSFloatType) {
		if (isNumeric && (isInt == NO)) {
		    return YES;
		} else {
		    return NO;
		}
	    } else if (entry_type == NSPositiveFloatType) {
		if (isNumeric && (isInt == NO) && isPositive) {
		    return YES;
		} else {
		    return NO;
		}		
	    } else if (entry_type == NSDoubleType) {
		if (isNumeric && (isInt == NO)) {
		    return YES;
		} else {
		    return NO;
		}
	    } else if (entry_type == NSPositiveDoubleType) {
		if (isNumeric && (isInt == NO) && isPositive) {
		    return YES;
		} else {
		    return NO;
		}		
	    }	   
	}
    }
    return YES;
}
#endif

@end
