/* 
   PXKFont.m

   NSFont for GNUstep GUI X/DPS Backend

   Copyright (C) 1996 Free Software Foundation, Inc.

   Author:  Scott Christley <scottc@net-community.com>
   Date: March 1996
   
   This file is part of the GNUstep GUI X/DPS Backend.

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   If you are interested in a warranty or support for this source code,
   contact Scott Christley <scottc@net-community.com> for more information.
   
   You should have received a copy of the GNU Library General Public
   License along with this library; see the file COPYING.LIB.
   If not, write to the Free Software Foundation,
   59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/ 

#include <gnustep/xdps/PXKFont.h>
#include <gnustep/xdps/PXKDPSContext.h>

extern NSString *gnustep_gui_system_family;

@implementation PXKFont

//
// Class methods
//
+ (void)initialize
{
  if (self == [PXKFont class])
    {
      NSDebugLog(@"Initialize PXKFont class\n");

      // Initial version
      [self setVersion:1];

      // Set the system font family name
      gnustep_gui_system_family = @"Times";
    }
}

//
// Setting the Font
//
- (void)set
{
  DPSContext ctxt = [(PXKDPSContext *)[NSDPSContext currentContext] 
				      xDPSContext];

  DPSPrintf(ctxt, "/%s findfont\n", [family_name cString]);
  DPSPrintf(ctxt, "%f scalefont setfont\n", point_size);
  NSLog(@"family %s point %f\n", [family_name cString], point_size);
  NSLog(@"font %s\n", [font_name cString]);
}

@end
