/* 
   buttons.m

   All of the various NSButtons

   Copyright (C) 1996 Free Software Foundation, Inc.

   Author:  Scott Christley <scottc@net-community.com>
   Date: June 1996
   
   This file is part of the GNUstep GUI X/DPS Backend.

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   If you are interested in a warranty or support for this source code,
   contact Scott Christley <scottc@net-community.com> for more information.
   
   You should have received a copy of the GNU Library General Public
   License along with this library; see the file COPYING.LIB.
   If not, write to the Free Software Foundation,
   59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/ 

#include <AppKit/AppKit.h>
#include <gnustep/xdps/PXKWindow.h>

int
main(int argc, char **argv)
{
    NSApplication *theApp;
    NSWindow *win;
    NSRect wf = {{100, 100}, {500, 600}};
    NSView *v;
    NSRect mf0 = {{250, 5}, {200, 500}};
    NSMatrix *mt0;

    NSButton *mpush, *ponpoff, *toggle, *swtch, *radio, *mchange, *onoff;
    NSRect bf0 = {{5, 5}, {200, 50}};
    NSRect bf1 = {{5, 60}, {200, 50}};
    NSRect bf2 = {{5, 115}, {200, 50}};
    NSRect bf3 = {{5, 170}, {200, 50}};
    NSRect bf4 = {{5, 225}, {200, 50}};
    NSRect bf5 = {{5, 280}, {200, 50}};
    NSRect bf6 = {{5, 335}, {200, 50}};

    initialize_gnustep_backend();

    theApp = [NSApplication sharedApplication];

    win = [[NSWindow alloc] init];
    v = [win contentView];

    NSLog(@"Create the buttons\n");
    mpush = [[NSButton alloc] initWithFrame: bf0];
    [mpush setTitle: @"MomentaryPush"];
    ponpoff = [[NSButton alloc] initWithFrame: bf1];
    [ponpoff setType: NSPushOnPushOffButton];
    [ponpoff setTitle: @"PushOnPushOff"];
    toggle = [[NSButton alloc] initWithFrame: bf2];
    [toggle setType: NSToggleButton];
    [toggle setTitle: @"Toggle"];
    swtch = [[NSButton alloc] initWithFrame: bf3];
    [swtch setType: NSSwitchButton];
    [swtch setBordered: NO];
    [swtch setTitle: @"Switch"];
    radio = [[NSButton alloc] initWithFrame: bf4];
    [radio setType: NSRadioButton];
    [radio setBordered: NO];
    [radio setTitle: @"Radio"];
    mchange = [[NSButton alloc] initWithFrame: bf5];
    [mchange setType: NSMomentaryChangeButton];
    [mchange setTitle: @"MomentaryChange"];
    onoff = [[NSButton alloc] initWithFrame: bf6];
    [onoff setType: NSOnOffButton];
    [onoff setTitle: @"OnOff"];

    NSLog(@"Make the buttons subviews\n");
    [v addSubview: mpush];
    [v addSubview: ponpoff];
    [v addSubview: toggle];
    [v addSubview: swtch];
    [v addSubview: radio];
    [v addSubview: mchange];
    [v addSubview: onoff];

    mt0 = [[NSMatrix alloc] initWithFrame: mf0 mode: NSHighlightModeMatrix
    			    cellClass: [NSMenuCell class]
    		    numberOfRows: 10 numberOfColumns: 3];
    [v addSubview: mt0];

    [win setFrame: wf display: YES];
    [win setTitle:@"GNUstep Buttons"];

    NSLog(@"Start the application\n");
    [theApp run];

    return 0;
}
