/* 
   nsimage.m

   Simple application to test NSImage classes.

   Copyright (C) 1996 Free Software Foundation, Inc.

   Author:  Scott Christley <scottc@net-community.com>
   Date: August 1996
   
   This file is part of the GNUstep GUI X/DPS Backend.

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with this library; see the file COPYING.LIB.
   If not, write to the Free Software Foundation,
   59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/ 

#include <AppKit/AppKit.h>
#include <gnustep/xdps/PXKWindow.h>
#include "ImageView.h"

int
main(int argc, char **argv)
{
    NSWindow *win;
    ImageView *v;
    NSApplication *theApp;
    NSImage *i;
    NSData *d;

    initialize_gnustep_backend();

    d = [NSData dataWithContentsOfFile: @"./crazycock.tiff"];
    printf("file length %d\n", [d length]);

    theApp = [NSApplication sharedApplication];

    NSLog(@"Create a window\n");
    win = [[NSWindow alloc] init];
    v = [[ImageView alloc] initWithFile: @"./crazycock.tiff"];
    [win setContentView: v];

    [win display];
    [win setTitle:@"GNUstep GUI X/DPS Image View"];

    NSLog(@"Run application\n");
    [theApp run];

    return 0;
}
