#include <AppKit/AppKit.h>
#include "TestView.h"

//
// my main for the test app
//
int
main(int argc, char **argv)
{
  NSApplication *theApp;
  NSWindow *w0, *w1;
  NSRect wf0 = {0, 0, 500, 500};
  char out[80];
  NSMenu *m0, *m1, *m2;
  NSMenuCell *mc0, *mc1, *mc2, *mc3;
  TestView *v, *v1;

#ifdef __MS_WIN32__
  // Initialize ourselves in Obj-C runtime
  init_testDPS();
#endif

  initialize_gnustep_backend();

  theApp = [NSApplication sharedApplication];

  //
  // Windows
  //
  w0 = [[NSWindow alloc] init];
  [w0 setTitle:@"Graphics Testing"];
  v = [[TestView alloc] init];
  [w0 setContentView: v];
  [w0 setFrame:wf0 display:YES];
#if 0
  w1 = [[NSWindow alloc] init];
  [w1 setTitle: @"Second Window"];
  v1 = [[TestView alloc] init];
  [w1 setContentView: v1];
  [w1 setFrame: wf0 display: YES];
#endif

  // Main menu
  m0 = [[NSMenu alloc] initWithTitle: @"testDPS"];
  mc0 = [m0 addItemWithTitle: @"Document" action: NULL
	    keyEquivalent: @""];
  mc1 = [m0 addItemWithTitle: @"Edit" action: NULL
	    keyEquivalent: @""];
  mc2 = [m0 addItemWithTitle: @"Windows" action: NULL
	    keyEquivalent: @""];
  mc2 = [m0 addItemWithTitle: @"Hide" action: @selector(hide:)
	    keyEquivalent: @"h"];
  [mc2 setTarget: theApp];
  mc2 = [m0 addItemWithTitle: @"Quit" action: @selector(terminate:)
	    keyEquivalent: @"q"];
  [mc2 setTarget: theApp];

  // Document submenu
  m1 = [[NSMenu alloc] initWithTitle: @"Document"];
  [m1 addItemWithTitle: @"New" action: NULL keyEquivalent: @""];
  [m1 addItemWithTitle: @"Open" action: NULL keyEquivalent: @""];
  [m1 addItemWithTitle: @"Save" action: NULL keyEquivalent: @""];
  [m0 setSubmenu: m1 forItem: mc0];

  // Edit submenu
  m1 = [[NSMenu alloc] initWithTitle: @"Edit"];
  [m1 addItemWithTitle: @"Cut" action: NULL keyEquivalent: @""];
  [m1 addItemWithTitle: @"Copy" action: NULL keyEquivalent: @""];
  [m1 addItemWithTitle: @"Paste" action: NULL keyEquivalent: @""];
  mc3 = [m1 addItemWithTitle: @"Find" action : NULL keyEquivalent: @""];
  [m0 setSubmenu: m1 forItem: mc1];

  // Find submenu
  m2 = [[NSMenu alloc] initWithTitle: @"Find"];
  [m2 addItemWithTitle: @"Find" action: NULL keyEquivalent: @""];
  mc2 = [m2 addItemWithTitle: @"Forward" action: @selector(terminate:)
	    keyEquivalent: @""];
  [mc2 setTarget: theApp];
  [m2 addItemWithTitle: @"Backward" action: NULL keyEquivalent: @""];
  [m1 setSubmenu: m2 forItem: mc3];

  [theApp setMainMenu: m0];
  [theApp run];

  [w0 release];
  //  [w1 release];
}

