/*
 * $Id: machdep-aout.S,v 1.1.1.1 1997/02/05 22:44:56 netcrep Exp $
 ****************************************************************************
 *    
 *  COPYRIGHT NOTICE
 *    
 *  Copyright (C) 1995, 1996 Michael T. Peterson
 *  This file is part of the PCthreads (tm) multithreading library
 *  package.
 *    
 *  The source files and libraries constituting the PCthreads (tm) package
 *  are free software; you can redistribute them and/or modify them under
 *  the terms of the GNU Library General Public License as published by the Free
 *  Software Foundation; either version 2 of the License, or (at your
 *  option) any later version.
 *    
 *  The PCthreads (tm) package is distributed in the hope that it will
 *  be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *    
 *  You should have received a copy of the GNU Library General Public
 *  License along with this library (see the file COPYING.LIB); if not,
 *  write to the Free Software Foundation, Inc., 675 Mass Ave, Cambridge,
 *  MA 02139, USA.
 *    
 *  To report bugs, bug fixes, or provide feedback you may contact the
 *  author, Michael T. Peterson, at either of the two email addresses listed
 *  below:
 *    
 *                 mtp@big.aa.net (Preferred)
 *                 mtp@zso.dec.com
 *    
 *    
 *  Michael T. Peterson
 *  Redmond, WA.
 *  12 January, 1996
 ****************************************************************************
 * $Log: machdep-aout.S,v $
 * Revision 1.1.1.1  1997/02/05 22:44:56  netcrep
 * PCThreads for Linux.
 *
 * Revision 1.1.1.1  1996/06/29 01:20:50  mtp
 * pthreads 1.0 distribution
 *
 * Revision 1.1.1.1  1996/06/28 15:45:40  mtp
 * Official V1.0 Sources
 *
 * Revision 2.0  1996/06/28 14:57:43  mtp
 * + Release 2.0
 *
 * Revision 1.2  1996/01/14 18:03:42  mtp
 * + Added copyright and permission notice.
 *
 * Revision 1.1.1.1  1995/12/16 21:41:59  mtp
 * Placed under CVS control
 *
 ****************************************************************************
 */
.text
.globl _sys_set_critical
.globl _sys_restore_critical
.globl _sys_get_return_value       /* Used in thread exit */
.globl _sys_save_fpu_context
.globl _sys_restore_fpu_context
.globl _sys_switch_thread_stacks   /* Yeah! */

   .align 4
_sys_set_critical:

       movl    $1, %eax
       xchgl   %eax, _critical
       ret

   .align 4
_sys_restore_critical:
       pushl   %ebp
       movl    %esp, %ebp

       movl    8(%ebp), %eax
       xchgl   %eax, _critical
       movl    %ebp, %esp

       popl    %ebp
       ret

   .align 4
_sys_get_return_value:
       ret

   .align 4
_sys_save_fpu_context:
        pushl %ebp
        movl %esp,%ebp
        movl 8(%ebp),%eax

        fnsave 32(%eax)

        movl %ebp,%esp
        popl %ebp
        ret

   .align 4
_sys_restore_fpu_context:
        pushl %ebp
        movl %esp,%ebp
        movl 8(%ebp),%eax

        frstor 32(%eax)

        movl %ebp,%esp
        popl %ebp
        ret

   .align 4
_sys_switch_thread_stacks:
       pushl  %ebp
       movl   %esp, %ebp

       movl   12(%ebp), %eax
       movl   %esp, 8(%eax)

       movl   8(%ebp), %edx
       movl   8(%edx), %esp

       popl   %ebp
       ret
