\# $Id: pthread_exit.man,v 1.1.1.1 1997/02/05 22:44:56 netcrep Exp $
\#---------------------------------------------------------------------------
\#    
\#  COPYRIGHT NOTICE
\#    
\#  Copyright (C) 1995, 1996 Michael T. Peterson
\#  This file is part of the PCthreads (tm) multithreading library
\#  package.
\#    
\#  The source files and libraries constituting the PCthreads (tm) package
\#  are free software; you can redistribute them and/or modify them under
\#  the terms of the GNU Library General Public License as published by the Free
\#  Software Foundation; either version 2 of the License, or (at your
\#  option) any later version.
\#    
\#  The PCthreads (tm) package is distributed in the hope that it will
\#  be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
\#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
\#  Library General Public License for more details.
\#    
\#  You should have received a copy of the GNU Library General Public
\#  License along with this library (see the file COPYING.LIB); if not,
\#  write to the Free Software Foundation, Inc., 675 Mass Ave, Cambridge,
\#  MA 02139, USA.
\#    
\#  To report bugs, bug fixes, or provide feedback you may contact the
\#  author, Michael T. Peterson, at either of the two email addresses listed
\#  below:
\#    
\#             mtp@big.aa.net (preferred)
\#             mtp@zso.dec.com
\#    
\#    
\#  Michael T. Peterson
\#  Redmond, WA.
\#  13 January, 1996
\#---------------------------------------------------------------------------
\# $Log: pthread_exit.man,v $
\# Revision 1.1.1.1  1997/02/05 22:44:56  netcrep
\# PCThreads for Linux.
\#
\# Revision 1.1.1.1  1996/06/29 01:20:50  mtp
\# pthreads 1.0 distribution
\#
\# Revision 1.1.1.1  1996/06/28 15:45:40  mtp
\# Official V1.0 Sources
\#
\# Revision 2.0  1996/06/28 14:57:50  mtp
\# + Release 2.0
\#
\# Revision 1.3  1996/01/14 20:22:25  mtp
\# + Modified copyright and permission notice to conform with GNU requirements.
\#
\# Revision 1.2  1996/01/14 18:32:06  mtp
\# + Replaced @Header@ with COPYRIGHT NOTICE.
\#
\# Revision 1.1.1.1  1995/12/16 21:41:59  mtp
\# Placed under CVS control
\#
\#---------------------------------------------------------------------------
.TH PCTHREADS 3 "July, 1995" PCTHREADS "POSIX Threads V1.0 For Linux"
.SH NAME
pthread_exit \- Terminate the calling thread
.SH SYNOPSIS
.B #include <pthread.h>
.sp
.B void
.br
.B pthread_exit( void *status )
.SH DESCRIPTION
The
.B pthread_exit()
function terminates the calling thread and makes a status value available to
any thread that calls
.B pthread_join()
specifying the terminating thread.
.PP
Any cancellation cleanup handlers that have been pushed, and not yet popped
from the thread's stack of handlers are executed in LIFO order.  After all
cleanup handlers have executed, and if the thread has any thread-specific data
the appropriate destructor functions are called.  The order in which
the destructor functions are called is unspecified.
.PP
.B NB:
Thread termination does not release any application visible thread or process
resources (e.g., mutexes and file descriptors).  PCthreads, however, will
print a warning to stderr if
.B pthread_exit()
is called with a locked mutex.
.PP
An implicit call to 
.B pthread_exit()
is made if the thread executes a normal return from its procedure.  In such
cases, the function's return value becomes the thread's exit status and is
passed to any threads that have requested a join.
.PP
If the thread calling
.B pthread_exit()
has been detached, it iss immediately destroyed and removed from the runtime.
Otherwise, it remains available to be joined and its exit status retrieved.
Once joined, however, the thread is immediately detached and destroyed.
.SH PARAMETERS
.SS Input Parameters
.IP status
Address value copied and returned to the caller of
.B pthread_join().
.SH RETURN VALUE
None.
.SH USAGE EXAMPLE
.PP
See manual page for the
.B pthread_join()
function.
.SH CONFORMING TO
POSIX .1c
.SH SEE ALSO
.B pthread_join(3), pthread_cleanup_push(3), pthread_cleanup_pop(3),
.B pthread_key_create(3), pthread_detach(3).
.SH AUTHOR
Michael T. Peterson <mtp@zso.dec. mtp@big.aa.net>







