\# $Id: pthread_key_getspecific.man,v 1.1.1.1 1997/02/05 22:44:56 netcrep Exp $
\#---------------------------------------------------------------------------
\#    
\#  COPYRIGHT NOTICE
\#    
\#  Copyright (C) 1995, 1996 Michael T. Peterson
\#  This file is part of the PCthreads (tm) multithreading library
\#  package.
\#    
\#  The source files and libraries constituting the PCthreads (tm) package
\#  are free software; you can redistribute them and/or modify them under
\#  the terms of the GNU Library General Public License as published by the Free
\#  Software Foundation; either version 2 of the License, or (at your
\#  option) any later version.
\#    
\#  The PCthreads (tm) package is distributed in the hope that it will
\#  be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
\#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
\#  Library General Public License for more details.
\#    
\#  You should have received a copy of the GNU Library General Public
\#  License along with this library (see the file COPYING.LIB); if not,
\#  write to the Free Software Foundation, Inc., 675 Mass Ave, Cambridge,
\#  MA 02139, USA.
\#    
\#  To report bugs, bug fixes, or provide feedback you may contact the
\#  author, Michael T. Peterson, at either of the two email addresses listed
\#  below:
\#    
\#             mtp@big.aa.net (preferred)
\#             mtp@zso.dec.com
\#    
\#    
\#  Michael T. Peterson
\#  Redmond, WA.
\#  13 January, 1996
\#---------------------------------------------------------------------------
\# $Log: pthread_key_getspecific.man,v $
\# Revision 1.1.1.1  1997/02/05 22:44:56  netcrep
\# PCThreads for Linux.
\#
\# Revision 1.1.1.1  1996/06/29 01:20:50  mtp
\# pthreads 1.0 distribution
\#
\# Revision 1.1.1.1  1996/06/28 15:45:40  mtp
\# Official V1.0 Sources
\#
\# Revision 2.0  1996/06/28 14:57:51  mtp
\# + Release 2.0
\#
\# Revision 1.3  1996/01/14 20:22:26  mtp
\# + Modified copyright and permission notice to conform with GNU requirements.
\#
\# Revision 1.2  1996/01/14 18:32:07  mtp
\# + Replaced @Header@ with COPYRIGHT NOTICE.
\#
\# Revision 1.1.1.1  1995/12/16 21:41:59  mtp
\# Placed under CVS control
\#
\#---------------------------------------------------------------------------
.TH PCTHREADS 3 "July, 1995" PCTHREADS "POSIX Threads V1.0 For Linux"
.SH NAME
pthread_key_getspecific \- Obtain thread-specific data by key
.br
pthread_key_setspecific \- Initialize thread-specific data by key
.SH SYNOPSIS
.B #include <pthread.h>
.sp
.B int
.br
.BI "pthread_key_getspecific(pthread_key_t " key ","
.br
.BI "                        void **" value )
.sp
.B int
.br
.BI "pthread_key_setspecific(pthread_key_t " key ","
.br
.BI "                        void *" value )
.SH DESCRIPTION
The 
.B pthread_key_getspecific()
routine obtains the calling thread's thread-specific data associated with the
.I key
parameter.  This key must have been initialized by a
previous call to the
.B pthread_key_create()
function.
.sp
The
.B pthread_key_setspecific()
routine initializes the calling thread's thread-specific data to the value 
specified by the
.I value
parameter.  An existing value, if present, for the specified key is replaced.
Different threads normally associate different values to the same key.  A
typical use for thread-specific data is to associate blocks of dynamically
allocated memory for use by the calling thread.
.SH PARAMETERS
.SS Input Parameters
.IP key
An identifier used to retrieve or initialize thread-specific data.
.IP value
When passed to the
.B pthread_setspecific()
function, 
.I value
is the address of the data to be associated with the calling thread's key.
.SS Return Parameters
.IP value
When passed to the
.B pthread_key_getspecific()
function, 
.I value
is the address of a pointer used by the thread library to store the pointer 
to the value associated with the
.I key
parameter.
.SH RETURN VALUE
A value of zero (0) is returned if no errors are encountered.
When an error condition arises, this routine returns an integer value 
indicating the reason for the error.  Possible error values are:
.TP
.IP EINVAL
The value specified by the 
.I key
parameter was invalid, or one or more of the parameters
was NULL.
.TP
.IP ENOMEM
The process's heap has become exhausted.
.SH USAGE EXAMPLE
.PP
See pthread_key_create()
.SH CONFORMING TO
POSIX .1c
.SH SEE ALSO
.B pthread_getspecific(3), pthread_setspecific(3), pthread_once(3)
.SH AUTHOR
Michael T. Peterson <mtp@zso.dec. mtp@big.aa.net>
