\# $Id: pthread_testcancel.man,v 1.1.1.1 1997/02/05 22:44:56 netcrep Exp $
\#---------------------------------------------------------------------------
\#    
\#  COPYRIGHT NOTICE
\#    
\#  Copyright (C) 1995, 1996 Michael T. Peterson
\#  This file is part of the PCthreads (tm) multithreading library
\#  package.
\#    
\#  The source files and libraries constituting the PCthreads (tm) package
\#  are free software; you can redistribute them and/or modify them under
\#  the terms of the GNU Library General Public License as published by the Free
\#  Software Foundation; either version 2 of the License, or (at your
\#  option) any later version.
\#    
\#  The PCthreads (tm) package is distributed in the hope that it will
\#  be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
\#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
\#  Library General Public License for more details.
\#    
\#  You should have received a copy of the GNU Library General Public
\#  License along with this library (see the file COPYING.LIB); if not,
\#  write to the Free Software Foundation, Inc., 675 Mass Ave, Cambridge,
\#  MA 02139, USA.
\#    
\#  To report bugs, bug fixes, or provide feedback you may contact the
\#  author, Michael T. Peterson, at either of the two email addresses listed
\#  below:
\#    
\#             mtp@big.aa.net (preferred)
\#             mtp@zso.dec.com
\#    
\#    
\#  Michael T. Peterson
\#  Redmond, WA.
\#  13 January, 1996
\#---------------------------------------------------------------------------
\# $Log: pthread_testcancel.man,v $
\# Revision 1.1.1.1  1997/02/05 22:44:56  netcrep
\# PCThreads for Linux.
\#
\# Revision 1.1.1.1  1996/06/29 01:20:51  mtp
\# pthreads 1.0 distribution
\#
\# Revision 1.1.1.1  1996/06/28 15:45:40  mtp
\# Official V1.0 Sources
\#
\# Revision 2.0  1996/06/28 14:57:53  mtp
\# + Release 2.0
\#
\# Revision 1.3  1996/01/14 20:22:28  mtp
\# + Modified copyright and permission notice to conform with GNU requirements.
\#
\# Revision 1.2  1996/01/14 18:32:09  mtp
\# + Replaced @Header@ with COPYRIGHT NOTICE.
\#
\# Revision 1.1  1996/01/10 19:01:08  mtp
\# + Placed under CVS control.
\#
\#---------------------------------------------------------------------------
.TH PCTHREADS 3 "July, 1995" PCTHREADS "POSIX Threads V1.0 For Linux"
.SH NAME
pthread_testcancel \- Deliver a cancel to the calling thread.
.SH SYNOPSIS
.B #include <pthread.h>
.sp
.B void
.br
.BI "pthread_testcancel("void)
.SH DESCRIPTION
The
.B pthread_testcancel()
requests the delivery of a pending cancel to the calling
thread.  The thread is cancelled only if a cancel is pending for the calling
thread, and its cancel state has the value PTHREAD_CANCEL_ENABLE.  If the
thread is cancellable, it will not return.
.SH PARAMETERS
.SS Input Parameters
.IP None
.SS Return Parameters
.IP None
.SH RETURN VALUE
None
.SH USAGE EXAMPLE
.PP
See man page for
.B pthread_cancel().
.SH CONFORMING TO
POSIX .1c
.SH SEE ALSO
.B pthread_cancel(), pthread_setcancelstate(), pthread_setcanceltype()
.SH AUTHOR
Michael T. Peterson <mtp@zso.dec.com,  mtp@big.aa.net>
