/*
 * $Id: nub.h,v 1.1.1.1 1997/02/05 22:44:57 netcrep Exp $
 ****************************************************************************
 *    
 *  COPYRIGHT NOTICE
 *    
 *  Copyright (C) 1995, 1996 Michael T. Peterson
 *  This file is part of the PCthreads (tm) multithreading library
 *  package.
 *    
 *  The source files and libraries constituting the PCthreads (tm) package
 *  are free software; you can redistribute them and/or modify them under
 *  the terms of the GNU Library General Public License as published by the Free
 *  Software Foundation; either version 2 of the License, or (at your
 *  option) any later version.
 *    
 *  The PCthreads (tm) package is distributed in the hope that it will
 *  be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *    
 *  You should have received a copy of the GNU Library General Public
 *  License along with this library (see the file COPYING.LIB); if not,
 *  write to the Free Software Foundation, Inc., 675 Mass Ave, Cambridge,
 *  MA 02139, USA.
 *    
 *  To report bugs, bug fixes, or provide feedback you may contact the
 *  author, Michael T. Peterson, at either of the two email addresses listed
 *  below:
 *    
 *             mtp@big.aa.net (preferred)
 *             mtp@zso.dec.com
 *    
 *    
 *  Michael T. Peterson
 *  Redmond, WA.
 *  13 January, 1996
 ****************************************************************************
 * $Log: nub.h,v $
 * Revision 1.1.1.1  1997/02/05 22:44:57  netcrep
 * PCThreads for Linux.
 *
 * Revision 1.1.1.1  1996/06/29 01:20:52  mtp
 * pthreads 1.0 distribution
 *
 * Revision 1.1.1.1  1996/06/28 15:45:41  mtp
 * Official V1.0 Sources
 *
 * Revision 2.0  1996/06/28 14:58:04  mtp
 * + Release 2.0
 *
 * Revision 1.3  1996/01/14 20:22:44  mtp
 * + Modified copyright and permission notice to conform with GNU requirements.
 *
 * Revision 1.2  1996/01/14 18:32:31  mtp
 * + Replaced @Header@ with COPYRIGHT NOTICE.
 *
 * Revision 1.1.1.1  1995/12/16 21:41:59  mtp
 * Placed under CVS control
 *
 ****************************************************************************
 */
#ifndef _nub_
#define _nub_
#include "private.h"

extern struct PTHREAD_HANDLE *
nub_get_active_thread( void );

extern int
nub_get_active_prio( void );

extern void
nub_set_active_prio( int prio );

extern void
nub_reschedule( struct PTHREAD_HANDLE *curr_th );

extern int
nub_reclaim_thread( struct PTHREAD_HANDLE *handle );

extern void
nub_flush_morgue( void );

extern counter_t
nub_get_intr_count( void );

extern counter_t
nub_get_ctxsw_count( void );

extern counter_t
nub_get_async_preemptions( void );

extern counter_t
nub_get_elapsed_usecs( void );

extern counter_t
nub_get_system_usecs( void );

extern int
nub_get_timeofday( struct timeval *tv, struct timezone *tz );

extern counter_t
nub_update_timer( void );

extern void
nub_set_idle_intr( counter_t count );

extern void
nub_set_sigaction( int sig, const struct sigaction *act );

extern void
nub_get_sigaction( int sig, struct sigaction *act );

#endif
